| ## grompp Main Table of Contents | VERSION 4.5 Thu 26 Aug 2010

### Description

The gromacs preprocessor reads a molecular topology file, checks the validity of the file, expands the topology from a molecular description to an atomic description. The topology file contains information about molecule types and the number of molecules, the preprocessor copies each molecule as needed. There is no limitation on the number of molecule types. Bonds and bond-angles can be converted into constraints, separately for hydrogens and heavy atoms. Then a coordinate file is read and velocities can be generated from a Maxwellian distribution if requested. grompp also reads parameters for the mdrun (eg. number of MD steps, time step, cut-off), and others such as NEMD parameters, which are corrected so that the net acceleration is zero. Eventually a binary file is produced that can serve as the sole input file for the MD program.

grompp uses the atom names from the topology file. The atom names in the coordinate file (option `-c`) are only read to generate warnings when they do not match the atom names in the topology. Note that the atom names are irrelevant for the simulation as only the atom types are used for generating interaction parameters.

grompp uses a built-in preprocessor to resolve includes, macros etcetera. The preprocessor supports the following keywords:
#ifdef VARIABLE
#ifndef VARIABLE
#else
#endif
#define VARIABLE
#undef VARIABLE
#include "filename"
#include <filename>
The functioning of these statements in your topology may be modulated by using the following two flags in your `mdp` file:
define = -DVARIABLE1 -DVARIABLE2
include = /home/john/doe
For further information a C-programming textbook may help you out. Specifying the `-pp` flag will get the pre-processed topology file written out so that you can verify its contents.

If your system does not have a c-preprocessor, you can still use grompp, but you do not have access to the features from the cpp. Command line options to the c-preprocessor can be given in the `.mdp` file. See your local manual (man cpp).

When using position restraints a file with restraint coordinates can be supplied with `-r`, otherwise restraining will be done with respect to the conformation from the `-c` option. For free energy calculation the the coordinates for the B topology can be supplied with `-rb`, otherwise they will be equal to those of the A topology.

Starting coordinates can be read from trajectory with `-t`. The last frame with coordinates and velocities will be read, unless the `-time` option is used. Note that these velocities will not be used when `gen_vel = yes` in your `.mdp` file. An energy file can be supplied with `-e` to read Nose-Hoover and/or Parrinello-Rahman coupling variables. Note that for continuation it is better and easier to supply a checkpoint file directly to mdrun, since that always contains the complete state of the system and you don't need to generate a new run input file. Note that if you only want to change the number of run steps tpbconv is more convenient than grompp.

Using the `-morse` option grompp can convert the harmonic bonds in your topology to morse potentials. This makes it possible to break bonds. For this option to work you need an extra file in your $GMXLIB with dissociation energy. Use the -debug option to get more information on the workings of this option (look for MORSE in the grompp.log file using less or something like that).

By default all bonded interactions which have constant energy due to virtual site constructions will be removed. If this constant energy is not zero, this will result in a shift in the total energy. All bonded interactions can be kept by turning off `-rmvsbds`. Additionally, all constraints for distances which will be constant anyway because of virtual site constructions will be removed. If any constraints remain which involve virtual sites, a fatal error will result.

To verify your run input file, please make notice of all warnings on the screen, and correct where necessary. Do also look at the contents of the `mdout.mdp` file, this contains comment lines, as well as the input that `grompp` has read. If in doubt you can start grompp with the `-debug` option which will give you more information in a file called grompp.log (along with real debug info). Finally, you can see the contents of the run input file with the `gmxdump` program.

### Files

option | filename | type | description
--- | --- | --- | ---
`-f` | `grompp.mdp` | Input, Opt. | grompp input file with MD parameters
`-po` | `mdout.mdp` | Output | grompp input file with MD parameters
`-c` | `conf.gro` | Input | Structure file: gro g96 pdb tpr etc.
`-r` | `conf.gro` | Input, Opt. | Structure file: gro g96 pdb tpr etc.
`-rb` | `conf.gro` | Input, Opt. | Structure file: gro g96 pdb tpr etc.
`-n` | `index.ndx` | Input, Opt. | Index file
`-p` | `topol.top` | Input | Topology file
`-pp` | `processed.top` | Output, Opt. | Topology file
`-o` | `topol.tpr` | Output | Run input file: tpr tpb tpa
`-t` | `traj.trr` | Input, Opt. | Full precision trajectory: trr trj cpt
`-e` | `ener.edr` | Input, Opt. | Energy file

### Other options

option | type | default | description
--- | --- | --- | ---
`-[no]h` | gmx_bool | `no` | Print help info and quit
`-[no]version` | gmx_bool | `no` | Print version info and quit
`-nice` | int | `0` | Set the nicelevel
`-[no]v` | gmx_bool | `no` | Be loud and noisy
`-time` | real | `-1` | Take frame at or first after this time.
`-[no]rmvsbds` | gmx_bool | `yes` | Remove constant bonded interactions with virtual sites
`-maxwarn` | int | `0` | Number of allowed warnings during input processing
`-[no]zero` | gmx_bool | `no` | Set parameters for bonded interactions without defaults to zero instead of generating an error
`-[no]renum` | gmx_bool | `yes` | Renumber atomtypes and minimize number of atomtypes

http://www.gromacs.org
gromacs@gromacs.org